#!/usr/bin/php
<?php
include "functions.php";
global $oids, $snmp_details;

//CISCO-CAR-MIB::
$oids = array (
		'ifIndex'	=>	'.1.3.6.1.4.1.9.9.113.1.1.1.1.4',	//ccarConfigAccIdx (because not all IF-MIB::ifIndex'es may exist in CAR tables)
		'ifName'	=>	'.1.3.6.1.2.1.31.1.1.1.1',		//IF-MIB::ifName
		'ifAlias'	=>	'.1.3.6.1.2.1.31.1.1.1.18',		//IF-MIB::ifAlias
		'ifDescr'	=>	'.1.3.6.1.2.1.2.2.1.2',			//IF-MIB::ifDescr
		'ifOperStatus'	=>	'.1.3.6.1.2.1.2.2.1.8',			//IF-MIB::ifOperStatus
		'cfgrate'	=>	'.1.3.6.1.4.1.9.9.113.1.1.1.1.5',	//ccarConfigRate
		'cfgextlimit' 	=>      '.1.3.6.1.4.1.9.9.113.1.1.1.1.6',	//ccarConfigExtLimit
		'cfglimit'	=>	'.1.3.6.1.4.1.9.9.113.1.1.1.1.7',	//ccarConfigLimit
                'switchedBytes' =>      '.1.3.6.1.4.1.9.9.113.1.2.1.1.11',      //ccarStatHCSwitchedBytes
                'filteredBytes' =>      '.1.3.6.1.4.1.9.9.113.1.2.1.1.13'       //ccarStatHCFilteredBytes
		);


$auth=explode("::",$_SERVER['argv'][2]);

$snmp_details['hostname']=$_SERVER['argv'][1];
$snmp_details['version']=$auth[0];
$snmp_details['community']=$auth[1];
$snmp_details['username']=$auth[2];
$snmp_details['password']=$auth[3];
if ($V=="0.8.7")
    $snmp_details['auth_proto']=$auth[4];
if ($V=="0.8.7")
    $snmp_details['priv_pass']=$auth[5];
if ($V=="0.8.7")
    $snmp_details['priv_proto']=$auth[6];
if ($V=="0.8.7")
    $snmp_details['context']=$auth[7];
$snmp_details['port']=($V=="0.8.7") ? $auth[8] : $auth[4];
$snmp_details['timeout']=($V=="0.8.7") ? $auth[9] : $auth[5];

$oid=(isset($_SERVER['argv'][5])) ? $_SERVER['argv'][5] : false;
$task=$_SERVER['argv'][3];
$target=(isset($_SERVER['argv'][4]) ? $_SERVER['argv'][4] : false);
 
if ($task=='query' || $task=='index') {
    if ($task=='index') $target='index';
    
    $ifInd=array();
    $preIfInd=response("ifIndex");
    foreach ($preIfInd as $preId => $preVal) {
	$ind=str_replace($oids["ifIndex"].".","",$preId);
	$suboid=substr($ind,0,strpos($ind,"."));
	$ifInd[$preId]=$ind;    
    }
    foreach ($ifInd as $ifIndexOid => $ifIndexVal) {
	$Index = str_replace($oids["ifIndex"].".","",$ifIndexOid);
	$ifIndexes[$ifIndexOid]=$Index;
    }
    
    switch ($target) {
    case "index":
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    if ($task=='query') 
		echo $ifIndexVal."::".$ifIndexVal."\n";
	    else
		echo $ifIndexVal."\n";
	}
	break;
    case "status":
	$statuses=response("ifOperStatus");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $index=substr($ifIndexVal,0,strpos($ifIndexVal,"."));
	    echo $ifIndexVal."::".($statuses[$oids["ifOperStatus"].".".$index]==1 ? "<font color=blue>Up</font>" : "<font color=red>Down</font>")."\n";
	}
	break;
    case "descr":
	$descrs=response("ifDescr");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $index=substr($ifIndexVal,0,strpos($ifIndexVal,"."));
	    echo $ifIndexVal."::".$descrs[$oids["ifDescr"].".".$index]."\n";
	}
	break;
    case "name":
	$names=response("ifName");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $index=substr($ifIndexVal,0,strpos($ifIndexVal,"."));
	    echo $ifIndexVal."::".$names[$oids["ifName"].".".$index]."\n";
	}
	break;
    case "alias":
	$aliases=response("ifAlias");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $index=substr($ifIndexVal,0,strpos($ifIndexVal,"."));
	    echo $ifIndexVal."::".$aliases[$oids["ifAlias"].".".$index]."\n";
	}
	break;
    case "cfglimit":
	$cfglimits=response("cfglimit");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    echo $ifIndexVal."::".$cfglimits[$oids["cfglimit"].".$ifIndexVal"]."\n";
	}
	break;
    case "cfgextlimit":
	$cfgextlimits=response("cfgextlimit");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    echo $ifIndexVal."::".$cfgextlimits[$oids["cfgextlimit"].".$ifIndexVal"]."\n";
	}
	break;
    case "direction":
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    $dir=substr($ifIndexVal,strpos($ifIndexVal,".")+1);
	    $dir=substr($dir,0,strrpos($dir,"."));
	    echo $ifIndexVal."::".($dir==1 ? "&nbsp;&darr;input" : "&nbsp;&uarr;output")."\n";
	}
	break;
    case "cfgrate":
	$cfgrates=response("cfgrate");
	foreach ($ifIndexes as $ifIndexOid => $ifIndexVal) {
	    echo $ifIndexVal."::".$cfgrates[$oids["cfgrate"].".$ifIndexVal"]."\n";
	}
	break;
    default:
	die("klaidingas parametras\n");
    }
} elseif ($task=='get' && ($target=='switchedBytes' || $target=='filteredBytes') ) {
    $result = @snmp_data($oids[$target].".$oid");
    if ($result===false) {
	echo "NaN";
    } else {
	echo (intval($result)==0) ? 0 : $result;
    }
} else {
    die("nepakanka parametru\n");
}

function response($task) {
    global $snmp_details,$oids;
    $results=false;

    $query = snmp_data_array($oids[$task]);

    foreach ($query as $ind => $q) {
	$results[".".$q['oid']]=$q['value'];
    }
    return $results;
}

?>
